package cn.org.bjca.trust.java.imserver.common.json;

import com.google.gson.*;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by xuqm on 2016/6/3.
 */
public class GsonImplHelp extends Json {
    private final Gson gson = new GsonBuilder()
            .setPrettyPrinting()
            .registerTypeAdapter(LocalDateTime.class, new LocalDateAdapter()).create();

    @Override
    public String toJson(Object src) {
        return gson.toJson(src);

    }

    @Override
    public <T> T toObject(String json, Class<T> claxx) {
        return gson.fromJson(json, claxx);

    }

    @Override
    public <T> T toObject(byte[] bytes, Class<T> claxx) {
        return gson.fromJson(new String(bytes), claxx);

    }

    public <T> List<T> toList(String json, Class<T> clazz) {
        JsonArray jsonArray = JsonParser.parseString(json).getAsJsonArray();

        List<T> list = new ArrayList<>();
        for (JsonElement jsonElement : jsonArray) {
            list.add(gson.fromJson(jsonElement, clazz)); //cls
        }

        return list;


    }

    public static <T> List<T> stringToArray(String s, Class<T[]> cls) {
        T[] array = new Gson().fromJson(s, cls);
        return Arrays.asList(array);
    }

}
