package cn.org.bjca.trust.java.imserver.controller.sys.v1;

import cn.org.bjca.trust.java.imserver.HttpResult;
import cn.org.bjca.trust.java.imserver.common.RabbitMQHelper;
import cn.org.bjca.trust.java.imserver.common.TimeHelper;
import cn.org.bjca.trust.java.imserver.entitys.sys.ApplicationEntity;
import cn.org.bjca.trust.java.imserver.entitys.sys.TenantEntity;
import cn.org.bjca.trust.java.imserver.repository.tenant.ApplicationRepository;
import cn.org.bjca.trust.java.imserver.repository.tenant.TenantRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Random;

@RestController
@RequestMapping("tenant/v1")
public class TenantV1Controller {

    @Autowired
    private TenantRepository tenantRepository;
    @Autowired
    private ApplicationRepository applicationRepository;

    @PostMapping("/tenant/create")
    public HttpResult<String> tenantCreate(@RequestBody TenantEntity tenant) throws Exception {
        if (null == tenant.getTenantName() ||
                null == tenant.getUserPhone() ||
                null == tenant.getUserEmail() ||
                null == tenant.getUserName()) {
            return new HttpResult<>(201, "参数错误", "");
        } else {
            TenantEntity t = tenantRepository.findFirstByUserEmailOrUserPhone(tenant.getUserEmail(), tenant.getUserPhone());
            if (null != t) return new HttpResult<>(201, "当前联系人已注册", "");
            t = new TenantEntity();
            t.setTenantName(tenant.getTenantName());
            t.setUserEmail(tenant.getUserEmail());
            t.setUserName(tenant.getUserName());
            t.setUserPhone(tenant.getUserPhone());
            t.setTenantNo(TimeHelper.getTimeString("yyyyMMddHHmm") + (new Random().nextInt(899999999) + 100000000));
            tenantRepository.save(t);

//            RabbitMQHelper.requestByGetAndParams("http://114.115.203.60:15672/api/vhosts/" + appid, "");
            return new HttpResult<>(200, "创建成功", "创建成功");
        }

    }

    @PostMapping("/app/create")
    public HttpResult<String> appCreate(@RequestBody ApplicationEntity application) throws Exception {
        if (null == application.getAppName() ||
                null == application.getTenantNo()) {
            return new HttpResult<>(201, "参数错误", "");
        } else {
            ApplicationEntity app = applicationRepository.findFirstByAppNameAndTenantNo(application.getAppName(), application.getTenantNo());
            if (null != app) return new HttpResult<>(201, "已创建相关类型的同名应用", "");
            app = new ApplicationEntity();
            app.setTenantNo(application.getTenantNo());
            app.setAppName(application.getAppName());
            app.setAppId(TimeHelper.getTimeString("yyyyMMddHHmm") + (new Random().nextInt(899999999) + 100000000));
            applicationRepository.save(app);

            RabbitMQHelper.requestByGetAndParams("http://114.115.203.60:15672/api/vhosts/" + app.getAppId(), "");
            return new HttpResult<>(200, "创建成功", "创建成功");
        }

    }

}
