package cn.org.bjca.trust.java.imserver.enums;

public enum PacketType {
    //连接请求
    CONNECT(10),
    CONNECTED(11),
    //发送消息
    SEND(20),
    SEND_ACK(21),
    //心跳包
    PING(40),
    PANG(41),
    //数据请求
    REQUEST(50),
    RESULT(51),
    //系统通知
    SYSTEM(60),
    SYSTEM_ACK(61),
    UNKNOWN(-1);

    private int type = -1;
    PacketType(final int type) {
        this.type = type;
    }

    public int type() {
        return this.type;
    }

    public static PacketType getType(final int type) {
        for (final PacketType value : PacketType.values()) {
            if (value.type == type) {
                return value;
            }
        }
        return UNKNOWN;
    }
}