package cn.org.bjca.trust.java.imserver.im.msg.msg;


import cn.org.bjca.trust.java.imserver.entitys.UserInfo;
import cn.org.bjca.trust.java.imserver.enums.MsgType;
import cn.org.bjca.trust.java.imserver.enums.PacketType;
import cn.org.bjca.trust.java.imserver.im.bean.PacketMessage;
import cn.org.bjca.trust.java.imserver.im.msg.msg.message.SZYXTextMessage;
import jakarta.persistence.*;
import lombok.Data;

@Entity
@Data
public class SZYXMessage extends PacketMessage {

    public SZYXMessage() {
        super(PacketType.SEND);
    }

    public SZYXMessage(MsgType msgType) {
        super(PacketType.SEND);
        this.msgType = msgType;
    }

    /**
     * 发送者信息
     */
    @OneToOne
    @JoinColumn(referencedColumnName = "token")
    private UserInfo fromClient;
    /**
     * 接收者信息
     */
    private String toClientId;
    /**
     * 群id
     */
    private String groupID;
    /**
     * 自定义信息(备注信息，描述信息)
     */
    @Column(name = "des")
    private String describe;
    /**
     * 是不是群消息
     */
    private boolean isGroup;
    /**
     * 是不是接收消息
     */
    private boolean isArrive;
    /**
     * 消息发送状态 -1=失败；0=成功；1=发送中
     */
    private int status;
    /**
     * 消息类型
     */
    private MsgType msgType;

    @OneToOne(cascade = CascadeType.ALL)
    @JoinColumn(name = "text_id", referencedColumnName = "_id")
    private SZYXTextMessage textMessage;

    public SZYXMessage copy() {
        SZYXMessage szyxMessage = new SZYXMessage(this.msgType);
        szyxMessage.setMsgId(this.getMsgId());
        szyxMessage.setPacketType(this.getPacketType());
        szyxMessage.setTimestamp(this.getTimestamp());
        szyxMessage.setUserName(this.getUserName());
        szyxMessage.setAppId(this.getAppId());
        szyxMessage.setToken(this.getToken());

        szyxMessage.setArrive(this.isArrive());
        szyxMessage.setDescribe(this.getDescribe());
        szyxMessage.setMsgType(this.getMsgType());
        szyxMessage.setToClientId(this.getToClientId());
        szyxMessage.setGroup(this.isGroup());
        szyxMessage.setStatus(this.getStatus());
        szyxMessage.setGroupID(this.getGroupID());

        szyxMessage.setFromClient(this.getFromClient().copy());

        SZYXTextMessage tm = new SZYXTextMessage();
        tm.setText(this.getTextMessage().getText());

        szyxMessage.setTextMessage(tm);
        return szyxMessage;
    }


}
